package com.mind.sample.three.ejb;

import java.util.Properties;

import javax.annotation.PostConstruct;
import javax.ejb.LocalBean;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.mind.sample.three.ejbClient.ThreeRemote;
import com.mind.sample.utils.ejb.BaseBean;

/**
 * Session Bean implementation class OneBean
 */
@Singleton
@Startup
@LocalBean
public class FourBean extends BaseBean
{

    /**
     * Default constructor.
     */
    public FourBean( )
    {
        System.out.println( "FourBean -  CTOR" );
    }

    @PostConstruct
    public void initialize( )
    {
        System.out.println( "FourBean -  doing initialize" );

        try
        {
            Properties jndi = getJNDIProp( );

            try
            {
                ThreeRemote stub = (ThreeRemote)new InitialContext( jndi ).lookup( "ejb:Three_EAR/three-ejb-0.0.1-SNAPSHOT//ThreeBean!"
                                                                                   + ThreeRemote.class.getName( ) );
                stub.doSomething( );
            }
            catch( NamingException e )
            {

                e.printStackTrace( );
            }
        }
        finally
        {

        }
        System.out.println( "FourBean -  doing initialize finished......." );

    }

}
