package com.mind.sample.one.ejb;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Map;
import java.util.Properties;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.mind.sample.one.ejbClient.OneObj;
import com.mind.sample.one.ejbClient.OneRemote;
import com.mind.sample.three.ejbClient.ThreeRemote;
import com.mind.sample.utils.Bridge;
import com.mind.sample.utils.ConnectionInitiator;
import com.mind.sample.utils.ejb.BaseBean;

/**
 * Session Bean implementation class OneBean
 */
@Stateless
public class OneBean extends BaseBean implements OneRemote {

	/**
	 * Default constructor.
	 */
	public OneBean() {
		System.out.println("OneBean - CTOR");
	}

	public OneObj doSomething() {
		System.out.println("OneBean - doing something");
		return new OneObj();
	}

	@Override
	public OneObj doSomething(Map<String, Object> params) {
	    Properties jndi = getJNDIProp( );
	    
		System.out.println("OneBean - doing something else---");
		Connection conn = ConnectionInitiator.getConnection("java:jboss/datasources/test/jdbc");
		System.out.println("OneBean -  got the connection");
		try {
			Bridge.performInsert(conn, "OneBean-insert", "OneBean-p", "OneBean-v");
			System.out.println("OneBean -  did the insert");
			/*try {
				ThreeRemote stub = (ThreeRemote) new InitialContext(jndi)
						.lookup("ejb:Three_EAR/three-ejb-0.0.1-SNAPSHOT//ThreeBean!" + ThreeRemote.class.getName());
				stub.doSomething( null );
			} catch (NamingException e) {

				e.printStackTrace();
			}*/
			System.out.println("OneBean -  did the lookup");
		} finally {
			try {
				conn.close();
			} catch (SQLException e) {

				e.printStackTrace();
			}
		}
		return new OneObj();
	}

}
