package com.mind.sample.three.ejb;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Map;
import java.util.Properties;

import javax.ejb.Stateless;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.mind.sample.three.ejbClient.ThreeObj;
import com.mind.sample.three.ejbClient.ThreeRemote;
import com.mind.sample.two.TwoRemote;
import com.mind.sample.utils.Bridge;
import com.mind.sample.utils.ConnectionInitiator;
import com.mind.sample.utils.ejb.BaseBean;

/**
 * Session Bean implementation class OneBean
 */
@Stateless
public class ThreeBean extends BaseBean implements ThreeRemote
{

    /**
     * Default constructor.
     */
    public ThreeBean( )
    {
        System.out.println( "ThreeBean -  CTOR" );
    }

    public ThreeObj doSomething( )
    {
        System.out.println( "ThreeBean -  doing something" );
        Connection conn = ConnectionInitiator.getConnection( "java:jboss/datasources/test/jdbc" );
        System.out.println( "ThreeBean -  got the connection" );
        try
        {
            Bridge.performInsert( conn, "ThreeBean-insert", "ThreeBean-p", "ThreeBean-v");
            System.out.println( "ThreeBean -  did the insert" );

            Properties jndi = getJNDIProp( );

            try
            {
                TwoRemote stub = (TwoRemote)new InitialContext( jndi ).lookup( "ejb:Two_EAR/two-ejb-0.0.1-SNAPSHOT//TwoBean!"
                                                                               + TwoRemote.class.getName( ) );
                stub.doSomething( );
            }
            catch( NamingException e )
            {

                e.printStackTrace( );
            }
        }
        finally
        {
            try
            {
                conn.close( );
            }
            catch( SQLException e )
            {

                e.printStackTrace( );
            }
        }
        return new ThreeObj( );
    }

    @Override
    public ThreeObj doSomething( Map<String, Object> params )
    {
        System.out.println( "ThreeBean - doing something else" );
        return new ThreeObj( );
    }

}
