package com.mind.sample.two.ejb;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.ejb.Stateless;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.mind.sample.one.ejbClient.AnotherObject;
import com.mind.sample.one.ejbClient.OneObj;
import com.mind.sample.one.ejbClient.OneRemote;
import com.mind.sample.two.TwoRemote;
import com.mind.sample.utils.Bridge;
import com.mind.sample.utils.ConnectionInitiator;
import com.mind.sample.utils.ejb.BaseBean;

/**
 * Session Bean implementation class TwoBean
 */
@Stateless
public class TwoBean extends BaseBean implements TwoRemote
{

    /**
     * Default constructor.
     */
    public TwoBean( )
    {
    }

    @Override
    public void doSomething( )
    {

        Properties jndi = getJNDIProp( );

        Connection conn = ConnectionInitiator.getConnection( "java:jboss/datasources/test/jdbc" );
        System.out.println( "TwoBean -  got the connection" );
        try
        {
            Bridge.performInsert( conn, "TwoBean-insert", "TwoBean-p", "TwoBean-v" );
            System.out.println( "TwoBean -  did the insert" );

            Map<String, Object> params = new HashMap<String, Object>( );
            Map<String, Object> someMap = new HashMap<String, Object>( );

            someMap.put( "11", false );
            someMap.put( "121", "aaaaaa" );
            someMap.put( "131", "remote.connection.default.password" );
            someMap.put( "114", false );

            params.put( "1", new AnotherObject( someMap, "ss", false, new AnotherObject( ), new OneObj( ) ) );

            try
            {
                OneRemote stub = (OneRemote)new InitialContext( jndi ).lookup( "ejb:One_EAR/one-ejb-0.0.1-SNAPSHOT//OneBean!"
                                                                               + OneRemote.class.getName( ) );
                stub.doSomething( params );
            }
            catch( NamingException e )
            {
                e.printStackTrace( );
            }

        }
        finally
        {
            try
            {
                conn.close( );
            }
            catch( SQLException e )
            {

                e.printStackTrace( );
            }
        }

    }

}
