package com.mind.sample.utils.ejb;

import java.util.Properties;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.interceptor.Interceptors;

import com.mind.sample.utils.LogInterceptor;

@Interceptors( LogInterceptor.class )
public class BaseBean
{

    @PostConstruct
    public void create( )
    {
        System.out.println( "doing create stuff" );
    }

    @PreDestroy
    public void destroy( )
    {
        System.out.println( "doing destroy stuff" );

    }

    protected Properties getJNDIProp( )
    {

        Properties jndi = new Properties( );

        jndi.put( "java.naming.factory.url.pkgs", "org.jboss.ejb.client.naming" );
        jndi.put( "org.jboss.ejb.client.scoped.context", "true" );
        jndi.put( "remote.connections", "default" );
        jndi.put( "remote.connection.default.host", "localhost" );
        jndi.put( "remote.connection.default.port", "4447" );
        jndi.put( "remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false" );
        jndi.put( "remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false" );
        jndi.put( "remote.connection.default.username", "remoting" );
        jndi.put( "remote.connection.default.password", "Remoting123_" );

        return jndi;
    }

}
